include "Vdp.inc"
include "Vram.inc"
include "Chars.inc"

ext ReadVram_, WriteVram_, FillVram_, CopyToVram_
ext PollVSync_

ext MonoPattern, LinePattern_, SpritePattern_

; void InitVram();
cseg
VdpValues:
    defb >02, >e2
    defb Vram_PatternName shr 10
    defb (Vram_Color shr 6) or >7f
    defb (Vram_PatternGenerator shr 11) or >03
    defb Vram_SpriteAttribute shr 7
    defb Vram_SpriteGenerator shr 11
    defb >f0
ColorSource:
	defb 64, 0f0h ; Ascii
	defb 16, 70h ; Logo
	defb 8, 70h ; CrackedFloor
	defb 1, 70h ; HardFloor
	defb 2, 0e0h ; Ladder
	defb 4, 0b0h ; Item
	defb 4, 0f0h ; Remain
    defb 0,0
CopyVram:
    dect r10 | mov r11,*r10
        li r3,>800
        do
            mov r2,r0
            bl @ReadVram_
            movb r0,r1
            mov r2,r0
            ai r0,>800
            bl @WriteVram_
            ai r0,>800
            bl @WriteVram_
            inc r2
            dec r3
        while ne | wend
    mov *r10+,r11
rt
InitVram_: public InitVram_
    dect r10 | mov r11,*r10
        li r1,VdpValues
        li r2,8
        li r0,>0080
        do
            movb *r1+,r0
            movb r0,@VdpPort+2 | swpb r0
            movb r0,@VdpPort+2 | swpb r0
            inc r0
            dec r2
        while ne | wend

        li r0,0
        do
            dect r10 | mov r0,*r10
                ai r0,Vram_PatternGenerator
                li r1,MonoPattern
                li r2,Char_End*CharHeight
                bl @CopyToVram_
            mov *r10+,r0
            dect r10 | mov r0,*r10
                ai r0,Vram_Color
                li r4,ColorSource
                do
                    clr r2
                    movb *r4+,r2
                while ne
                    srl r2,8-3
                    movb *r4+,r1
                    bl @FillVram_
                    a r2,r0
                wend
            mov *r10+,r0
            ai r0,>0800
            ci r0,>1800
        while ne | wend
    mov *r10+,r11
rt


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    dect r10 | mov r11,*r10
        li r0,Vram
        li r1,Char_Space shl 8
        li r2,VramWidth*VramHeight
        bl @FillVram_

        li r0,Vram_SpriteAttribute
        li r1,>c0 shl 8
        li r2,4*32
        bl @FillVram_
    mov *r10+,r11
rt


; word VramAddress(byte x, byte y);
cseg
VramAddress_: public VramAddress_
    dect r10 | mov r1,*r10
        srl r1,8-5
        srl r0,8
        a r1,r0
        ai r0,Vram
    mov *r10+,r1
rt


; word Put(word vram, byte c);
cseg
Put_: public Put_
    dect r10 | mov r11,*r10
        bl @WriteVram_
        inc r0
    mov *r10+,r11
rt


; word PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    dect r10 | mov r11,*r10
    dect r10 | mov r1,*r10
        ai r1,-(' ' shl 8)
        bl @WriteVram_
        inc r0
    mov *r10+,r1
    mov *r10+,r11
rt


; void VPut2(byte x, byte y, byte pattern);
cseg
VPut2_: public VPut2_
    dect r10 | mov r11,*r10
    dect r10 | mov r0,*r10
    dect r10 | mov r1,*r10
    dect r10 | mov r2,*r10
    dect r10 | mov r3,*r10
        srl r1,8-5
        srl r0,8
        a r1,r0
        ai r0,Vram

        mov r2,r1
        li r2,2
        do
            li r3,2
            do
                bl @WriteVram_
                inc r0
                ai r1,>100
                dec r3
            while ne | wend
            ai r0,VramWidth-2
            dec r2
        while ne | wend
    mov *r10+,r3
    mov *r10+,r2
    mov *r10+,r1
    mov *r10+,r0
    mov *r10+,r11
rt


; void VErase2(byte x, byte y);
cseg
VErase2_: public VErase2_
    dect r10 | mov r11,*r10
    dect r10 | mov r0,*r10
    dect r10 | mov r1,*r10
    dect r10 | mov r2,*r10
    dect r10 | mov r3,*r10
        srl r1,8-5
        srl r0,8
        a r1,r0
        ai r0,Vram

        li r1,' ' shl 8
        li r2,2
        do
            li r3,2
            do
                bl @WriteVram_
                inc r0
                dec r3
            while ne | wend
            ai r0,VramWidth-2
            dec r2
        while ne | wend
    mov *r10+,r3
    mov *r10+,r2
    mov *r10+,r1
    mov *r10+,r0
    mov *r10+,r11
rt
